



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>HBase行锁</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">HBase行锁</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-26 16:04:59 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<div>
<h1>1 行锁简介</h1>
<p>在事务特性方面，hbase只支持单row的事务，不能保证跨row(cross-row)的事务。hbase通过行锁来实现单row事务。客户端进行操作时，可以显式对某一个行加锁，但是大部分情况下是没有必要的，因为如果没有显式的加行锁，hbase在内部会默认的加行锁。为了描述方便，用户显式加的行锁简称为显式行锁。</p>
<p>源码1：客户端使用显式行锁的示例代码</p>
<p>HTable table = new HTable(config, tablename);</p>
<p>RowLock lock = table.lockRow(rowkey);//首先获得rowkey对应的行锁，可能阻塞</p>
<p>Put p1 = new Put(rowkey,lock);</p>
<p>p1.add(cf, qua,value); //在行rowkey上，写数据</p>
<p>table.put(p1);</p>
<p>table.unlockRow(lock);//解锁</p>
<p>hbase不推荐客户端显式加行锁，因为可能造成regionserver死锁。并且现在正就"客户端不支持显式加行锁"进行讨论。</p>
<p>引自hbase官网：</p>
<p><a href="http://hbase.apache.org/apidocs/org/apache/hadoop/hbase/client/HTable.html" rel="external nofollow noreferrer">RowLocks</a> are still in the client API<em>however</em> they are<br />
discouraged because if not managed properly thesecan lock up the RegionServers. There is an oustanding ticket<a href="https://issues.apache.org/jira/browse/HBASE-2332" rel="external nofollow noreferrer">HBASE-2332</a><br />
 to remove this feature from the client.</p>
<h1>2 实现行锁</h1>
<p>如下图所示，客户端看到的行锁由两部分组成：rowkey和外部锁id。外部锁id是向regionserver申请行锁时，由regionserver返回的。外部锁id在对应的regionserver上全局唯一。</p>
<p><img referrerpolicy="no-referrer"src="http://img3.ph.126.net/Go7oBwp3Y7clFup7hDF1sw==/1132092356347491793.jpg"></p>
<p>图1 行锁的定义</p>
<p>如图2所示。一个regionserver对应一个HRegionServer实例，一个分片对应一个HRegion实例。</p>
<p>在HregionServer中提供两个接口lockRow和unlockRow，供客户端显式加锁和解锁。rowlocks存储了&lt;客户端所见的锁id，内部锁id&gt;的映射关系。因为内部锁id在分片内部是唯一的，但是在regionserver上不唯一，所以需要这个映射关系。</p>
<p>在HRegion中，lockedRows记录了所有已经加锁的行，lockIds记录了映射关系&lt;内部锁id，rowkey&gt;。</p>
<p><img referrerpolicy="no-referrer"src="http://img0.ph.126.net/VDIR6FkYzsB7ALHMdtUMTQ==/1554867771366894630.jpg"></p>
<p>图2</p>
<p>为了处理客户端忘记释放锁的情况，显式行锁有一个租约(即有效期，默认是60秒，可配置，对应的配置项是hbase.regionserver.lease.period)，如果显式行锁超过了租约时间，regionserver会自动释放行锁。在租约时间内，如果又收到了在这个行上的写请求，会延长租约时长。</p>
<p><strong>加显式行锁的算法 </strong></p>
<p>1 判断目标行是否已经加锁，如果已经加锁，则等待至解锁。</p>
<p>while (lockedRows.contains(row))</p>
<p>lockedRows.wait();</p>
<p>2 分配内部锁id，记为lockId。并把映射关系&lt;lockIds,row&gt;加入至lockIds。lockId在region内是唯一的。</p>
<p>保证内部锁id唯一性的常规的解决办法是：找出一个没有使用过的id，然后分配给行锁。hbase采用的方法比较有意思：在内部维护一个id生成器，每次分配时，把id生成器的值分配给行锁，并且id生成器自增1。如果没有出现冲突(冲突：当前分配的id不唯一)，分配完成。 如果出现冲突，为id生成器赋一随机值，然后重复的上面的流程，直到没有冲突，见源码2。</p>
<p>方法对比：如果使用常规方法，必然要使用到锁来进行并发控制，锁的开销还是比较大的。hbase认为出现冲突的可能性非常小，这种方法的开销应该远小于常规方法。这种提供性能的方法值得学习。</p>
<p>源码2：分配内部锁id。 见HRegion. internalObtainRowLock()</p>
<p>byte[] prev = null;</p>
<p>Integer lockId = null;</p>
<p>do</p>
<p>{</p>
<p>lockId = new Integer(lockIdGenerator++);//生成锁id</p>
<p>prev = lockIds.put(lockId, row);</p>
<p>if (prev != null)<br />
//如果lockId已经分配了，即发生冲突</p>
<p>{</p>
<p>lockIds.put(lockId, prev);// 恢复被破坏的映射关系</p>
<p>lockIdGenerator = rand.nextInt();//生成新的锁id</p>
<p>}</p>
<p>} while (prev != null);</p>
<p>源码：添加映射关系</p>
<p>lockIds.put(lockId, row)</p>
<p>3 把目标行加入至lockedRows。</p>
<p>lockedRows.add(row);</p>
<p>4 为行锁分配外部锁id，这个id在regionserver内是唯一的。</p>
<p>lockId = rand.nextLong();//这种方法会给hbase带来问题，见第三节</p>
<p>5 在行锁上添加行锁监听器。</p>
<p>行锁监听器的主要功能是处理行锁的租约，租约过期时，自动释放行锁，收到新的写请求延长租约时长。</p>
<p>下图是实现行锁的类图。</p>
<p><img referrerpolicy="no-referrer"src="http://img9.ph.126.net/TVKat1gswXZPU1tCgrGHqQ==/1012746966222168629.jpg"></p>
<p><strong>图3 实现行锁类图</strong></p>
<h1>3 设计缺陷</h1>
<p>在加显式行锁算法的第4步中，因为Random对象可能产生重复的值，所以分配的外部锁id可能不唯一。</p>
<p>通过修改regionserver的代码，模拟生成重复锁id的情况，测试流程如下：</p>
<p>1修改regionserver的代码使得每次分配的外部锁id都为999</p>
<p>2线程1为rowkey1申请行锁；线程2为rowkey2申请行锁。线程1和线程2同时并发运行。</p>
<p>测试发现只要只要rowkey1对应的行锁不释放，线程2会永远阻塞。</p>
<p>修正方法：保证外部锁id的唯一性。</p>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/0qw5023q.html">android&colon;descendantFocusability用法简析</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q7gzo1q.html">JSP自定义标签&mdash;&mdash;调用数据库（通过id号搜索相关信息）</a>
		</li>
						<li><a href="https://www.batexi.com/a/0qwx75k9.html">URL中&OpenCurlyDoubleQuote;&num;&rdquo; &OpenCurlyDoubleQuote;？&rdquo; &amp;amp&semi;&OpenCurlyDoubleQuote;&rdquo;号的作用</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pj3dgk9.html">&lbrack;css&rsqb;兼容性</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wnl5oq.html">ANDROID&lowbar;MARS学习笔记&lowbar;S05&lowbar;003&lowbar;传感器采样率及属性</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1z2oe9.html">Unity3D中使用KiiCloud总结一</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gemyp78.html">探索Oracle之数据库升级七   11gR2 to 12c 升级完毕后插入PDB</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyylkj9.html">Oracle cloud control 12c 的启动与关闭</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv1d771q.html">上海赛区-org&period;apache&period;ibatis&period;type&period;TypeException&colon; JDBC requires that the JdbcType must be specified for all nullable parameters&period;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zorjndq.html">MapReduce 多表连接</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjyy4z8.html">Java 中的日期与时间</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojm50lq.html">C&plus;&plus;中的继承&lpar;3&rpar;作用域与重定义，赋值兼容规则</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyd1yj9.html">目前在segmentfault写博客</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj7lw5q.html">RSA Encrypting&sol;Decrypting、RSA&plus;AES Encrypting&sol;Decrypting</a>
		</li>
						<li><a href="https://www.batexi.com/a/8o14d15q.html">filter帅选</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r51p07q.html">REST API 调用 方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o2j118.html">Python学习之路基础篇--01Python的基本常识</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j3vg3q.html">PMP：7&period;项目成本管理</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rd1d68.html">easyui的datebox控件如何只要年月不要日谢谢知道的说一下</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kj40p69.html">深入springboot原理&mdash;&mdash;动手封装一个starter</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93y11gr8.html">Android简易实战教程--第二十九话《创建图片副本》</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj04rx9.html">SQL Server2012 AlwaysOn 无法将数据库联接到可用性组 针对主副本的连接未处于活动状态</a>
			</li>
						<li><a href="https://www.batexi.com/a/8me41yoq.html">【一天一道LeetCode】&num;202&period; Happy Number</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojrmlpq.html">【一天一道LeetCode】&num;349&period; Intersection of Two Arrays</a>
			</li>
						<li><a href="https://www.batexi.com/a/qy13m62q.html">【嵌入式开发】嵌入式 开发环境 &lpar;远程登录 &vert; 文件共享 &vert; NFS TFTP 服务器 &vert; 串口连接 &vert; Win8&period;1 &plus; RedHat Enterprise 6&period;3 &plus; Vmware11&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlj0yve9.html">SQL Server性能优化与管理的艺术 附件下载地址</a>
			</li>
						<li><a href="https://www.batexi.com/a/8eykp6k9.html">spring struts2 ibatis 框架结构图</a>
			</li>
						<li><a href="https://www.batexi.com/a/93y2op08.html">hadoop队列管理（指定queue跑程序）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjmkgz8.html">Scipy教程 - 距离计算库scipy&period;spatial&period;distance</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwjmk1z8.html">Android移动后端服务&lpar;BAAS&rpar;快速搭建后台服务器之Bmob-android学习之旅&lpar;75&rpar;</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
